/*========================================================================
Nom: WidgetDistant.cpp           auteur: Maneschi Romain
Maj: 17.05.2009                  Creation: 20.04.2009
Projet: MYW
--------------------------------------------------------------------------
Specification:
Classe conteneur de DossiersDistants.
=========================================================================*/

#include <iostream>
using namespace std;

#include "WidgetDistant.h"
#include "FTPBrowser.h"

WidgetDistant::WidgetDistant(FTPBrowser * p) : QWidget(p)
{
    parent = p;
    serveur_en_cours = -1;
    home_dir = "";
    verifier_existe_deja = true;

    put_s = new QList<struct_put_get>();
    get_s = new QList<struct_put_get>();

    QVBoxLayout * layout = new QVBoxLayout(this);

    QHBoxLayout * ss_layout = new QHBoxLayout();
    emplacement = new QLineEdit(this);
    connect(emplacement, SIGNAL(textEdited(QString)), this, SLOT(verificationEmplacement(QString)));
    connect(emplacement, SIGNAL(returnPressed()), this, SLOT(emplacementNormalePalette()));

    cd_ou_cdparent = new QPushButton("", this);
    cd_ou_cdparent->setToolTip(tr("Rpertoire parent"));
    cd_ou_cdparent->setFlat(true);
    cd_ou_cdparent->setIconSize(QSize(25, 25));
    cd_ou_cdparent->setMaximumSize(25, 25);
    cdOuCdParent(false);

    ss_layout->addWidget(emplacement);
    ss_layout->addWidget(cd_ou_cdparent);
    layout->addLayout(ss_layout);

    //qtreewidget contenant les rep et dir
    distant = new DossiersDistants(this);
    layout->addWidget(distant);

    ss_layout = new QHBoxLayout();
    //home dir
    bouton_home_repertoir = new QPushButton(QIcon(":/FTPImages/home.png"), "", this);
    bouton_home_repertoir->setToolTip(tr("Accueil"));
    bouton_home_repertoir->setMaximumSize(70, 60);
    bouton_home_repertoir->setMinimumSize(60, 60);
    bouton_home_repertoir->setIconSize(QSize(60, 60));
    connect(bouton_home_repertoir, SIGNAL(clicked()), this, SLOT(cdHome()));
    ss_layout->addWidget(bouton_home_repertoir);
    //crer dir
    bouton_nouveau_repertoir = new QPushButton(QIcon(":/FTPImages/newdossier.png"), "", this);
    bouton_nouveau_repertoir->setToolTip(tr("Crer Dossier"));
    bouton_nouveau_repertoir->setMaximumSize(70, 60);
    bouton_nouveau_repertoir->setMinimumSize(60, 60);
    bouton_nouveau_repertoir->setIconSize(QSize(55, 55));
    connect(bouton_nouveau_repertoir, SIGNAL(clicked()), this, SLOT(widgetAjouterDossier()));
    ss_layout->addWidget(bouton_nouveau_repertoir);
    //recharger
    bouton_recharger = new QPushButton(QIcon(":/FTPImages/reload.png"), "", this);
    bouton_recharger->setToolTip(tr("Recharger"));
    bouton_recharger->setMaximumSize(70, 60);
    bouton_recharger->setMinimumSize(60, 60);
    bouton_recharger->setIconSize(QSize(50, 50));
    connect(bouton_recharger, SIGNAL(clicked()), this, SLOT(recharger()));
    ss_layout->addWidget(bouton_recharger);
    layout->addLayout(ss_layout);

    enabledDisabledBoutons();

    setAttribute(Qt::WA_DeleteOnClose);
}

void WidgetDistant::enabledDisabledBoutons()
{
    if(distant->getFtp()->state() == QFtp::LoggedIn)
    {
        distant->setEnabled(true);
        emplacement->setEnabled(true);
        cd_ou_cdparent->setEnabled(true);
        bouton_home_repertoir->setEnabled(true);
        bouton_nouveau_repertoir->setEnabled(true);
        bouton_recharger->setEnabled(true);
    }
    else
    {
        distant->setEnabled(false);
        emplacement->setEnabled(false);
        cd_ou_cdparent->setEnabled(false);
        bouton_home_repertoir->setEnabled(false);
        bouton_nouveau_repertoir->setEnabled(false);
        bouton_recharger->setEnabled(false);
    }
}

void WidgetDistant::connexion(int i)
{
    struct_serveur temp = parent->getServeurFTP(i);
    if(!temp.proxy.isEmpty())
    {
        distant->getFtp()->setProxy(temp.proxy, temp.port_proxy);
    }
    distant->getFtp()->connectToHost(temp.url, temp.port);
    distant->getFtp()->login(temp.login, temp.pass);
    home_dir = QString(temp.home);
    serveur_en_cours = i;
}

void WidgetDistant::reconnexion()
{
    connexion(serveur_en_cours);
}

void WidgetDistant::cdHome()
{
    if(home_dir.isEmpty())
    {
        distant->getFtp()->cd("/");
    }
    else
    {
        distant->getFtp()->cd(home_dir);
    }
    distant->clear();
    distant->getFtp()->list();
    distant->setRepCourant(home_dir);
    mettreAJourEmplacement();
    emplacementNormalePalette(true);
    if(home_dir.isEmpty())
    {
        parent->getMessages()->ajouterMessage(QIcon(":/FTPImages/computer.png"), tr("Dplacement dans le dossier <i><b>/</b></i>"), 0);
    }
    else
    {
        parent->getMessages()->ajouterMessage(QIcon(":/FTPImages/computer.png"), tr("Dplacement dans le dossier <i><b>")+home_dir+tr("</b></i>"), 0);
    }
    parent->getCommandes()->downloadOnOff(false);
}

void WidgetDistant::recharger()
{
    distant->clear();
    distant->getFtp()->list();
    mettreAJourEmplacement();
    emplacementNormalePalette(true);
    parent->getCommandes()->downloadOnOff(false);
}

void WidgetDistant::widgetAjouterDossier()
{
    QWidget * w = new QWidget(this, Qt::Dialog);
    w->setWindowTitle(tr("Ajouter un dossier"));
    QVBoxLayout * layout = new QVBoxLayout(w);

    QHBoxLayout * ss_layout = new QHBoxLayout();
    QLabel * l = new QLabel(tr("Emplacement : "));
    ss_layout->addWidget(l);
    QString temp;
    if(distant->getRepCourant().isEmpty())
    {
        temp = "/";
    }
    else
    {
        temp = distant->getRepCourant();
    }
    emplacement_dossier = new QLineEdit(temp);
    emplacement_dossier->setEnabled(false);
    ss_layout->addWidget(emplacement_dossier);
    layout->addLayout(ss_layout);

    ss_layout = new QHBoxLayout();
    l = new QLabel(tr("Nom : "));
    ss_layout->addWidget(l);
    nom_dossier = new QLineEdit();
    nom_dossier->setFocus(Qt::ActiveWindowFocusReason);
    ss_layout->addWidget(nom_dossier);
    layout->addLayout(ss_layout);

    ss_layout = new QHBoxLayout();
    QPushButton * annuler = new QPushButton(QIcon(":/FTPImages/annuler.png"), tr("Annuler"));
    ss_layout->addWidget(annuler);
    QPushButton * ok = new QPushButton(QIcon(":/FTPImages/valider.png"), tr("Valider"));
    ss_layout->addWidget(ok);
    layout->addLayout(ss_layout);

    w->setMinimumSize(400, 100);
    w->show();
    connect(annuler, SIGNAL(clicked()), w, SLOT(close()));
    connect(ok, SIGNAL(clicked()), this, SLOT(widgetAjouterDossierOk()));
    connect(ok, SIGNAL(clicked()), w, SLOT(close()));
}

void WidgetDistant::widgetAjouterDossierOk()
{
    distant->getFtp()->mkdir(nom_dossier->text());
    recharger();
    parent->getMessages()->ajouterMessage(QIcon(":/FTPImages/bon.gif"), tr("Dossier ")+nom_dossier->text()+tr(" ajout."), 0);
}

void WidgetDistant::mettreAJourEmplacement()
{
    QString s = distant->getRepCourant();
    if(s.indexOf("/") == 0 &&  s.indexOf("/", 1) == 1)
    {
        s = s.right(s.length()-1);
    }
    if(s.isEmpty())
    {
        emplacement->setText("/");
    }
    else
    {
        emplacement->setText(s);
    }
    if(distant->getRepCourant() == home_dir)
    {
        bouton_home_repertoir->setEnabled(false);
    }
    else
    {
        bouton_home_repertoir->setEnabled(true);
    }
    if(distant->getRepCourant() == "/" || distant->getRepCourant().isEmpty())
    {
        cd_ou_cdparent->setEnabled(false);
    }
    else
    {
        cd_ou_cdparent->setEnabled(true);
    }
}

FTPBrowser* WidgetDistant::getParent()
{
    return parent;
}

QString WidgetDistant::getRepCourant()
{
    return distant->getRepCourant();
}

QFtp* WidgetDistant::getFtp()
{
    return distant->getFtp();
}

void WidgetDistant::verificationEmplacement(QString s)
{
    QPalette palette(emplacement->palette());
    s = s.split("/").last();

    if(distant->existeDeja(s))
    {
        palette.setColor(QPalette::Base, QColor(0,255,0));
        emplacement->setPalette(palette);
    }
    else
    {
        palette.setColor(QPalette::Base, QColor(255,0,0));
        emplacement->setPalette(palette);
    }

    cdOuCdParent(true);
}

void WidgetDistant::emplacementNormalePalette(bool par_prog)
{
    QString s = emplacement->text();
    s = s.split("/").last();
//    cout<<s.toStdString()<<endl;
    if(distant->existeDeja(s) || par_prog)
    {
        QPalette palette(emplacement->palette());
        palette.setColor(QPalette::Base, QColor(255,255,255));
        emplacement->setPalette(palette);

        distant->getFtp()->cd(s);
        distant->clear();
        distant->getFtp()->list();
        distant->setRepCourant(emplacement->text());
        mettreAJourEmplacement();
        cdOuCdParent(false);
    }
    else
    {
        verificationEmplacement(emplacement->text());
        cdOuCdParent(true);
    }
}

void WidgetDistant::cdOuCdParent(bool b)//true si cd false sinon
{
    cd_ou_cdparent->disconnect();
    if(b)
    {
        cd_ou_cdparent->setIcon(QIcon(":/FTPImages/bon.gif"));
        cd_ou_cdparent->setToolTip(tr("Aller  "));
        connect(cd_ou_cdparent, SIGNAL(clicked()), emplacement, SIGNAL(returnPressed()));
        cd_ou_cdparent->setEnabled(true);
    }
    else
    {
        cd_ou_cdparent->setIcon(QIcon(":/FTPImages/up.png"));
        cd_ou_cdparent->setToolTip(tr("Rpertoire parent"));
        connect(cd_ou_cdparent, SIGNAL(clicked()), this, SLOT(cdUp()));
    }
}

void WidgetDistant::cdUp()
{
    QString rep = distant->getRepCourant().left(distant->getRepCourant().lastIndexOf("/"));
    distant->getFtp()->cd("..");
    distant->clear();
    distant->getFtp()->list();
    distant->setRepCourant(rep);
    mettreAJourEmplacement();
    if(rep.isEmpty())
    {
        parent->getMessages()->ajouterMessage(QIcon(":/FTPImages/computer.png"), tr("Dplacement dans le dossier <i><b>/</b></i>"), 0);
    }
    else
    {
        parent->getMessages()->ajouterMessage(QIcon(":/FTPImages/computer.png"), tr("Dplacement dans le dossier <i><b>")+rep+tr("</b></i>"), 0);
    }
    parent->getCommandes()->downloadOnOff(false);
}

QString WidgetDistant::getHomeDir()
{
    return home_dir;
}

void WidgetDistant::put(QString chemin_fichier/*chemin absolu*/, QIcon icon)
{
    QFile * file_temp = new QFile(chemin_fichier);
    QString nom = chemin_fichier.split("/").last();

    if(distant->getFtp()->state() == QFtp::LoggedIn)
    {
        if(distant->existeDeja(nom) && verifier_existe_deja)
        {
            widgetRemplacementFichier(nom, icon);
        }
        if(!distant->existeDeja(nom) || !verifier_existe_deja)
        {
            struct_put_get temp;
            temp.file = file_temp;
            temp.nom = nom;
            put_s->append(temp);

            parent->getMessages()->ajouterTelechargement(icon, chemin_fichier, true/*upload*/);
        }
    }
    else
    {
        parent->getMessages()->ajouterMessage(QIcon(":/FTPImages/mauvais.gif"), tr("Vous n'tes connect  aucun serveur."), new QLabel(tr("Erreur")));
    }
}

void WidgetDistant::lancerPut(int serveur)
{
    distant->getFtp()->put(put_s->value(serveur).file, put_s->value(serveur).nom);
}

void WidgetDistant::get(QString nom/*chemin absolu*/, QIcon icon)
{
    QString nom_fichier = nom.split("/").last();

    if(distant->getFtp()->state() == QFtp::LoggedIn)
    {
        bool existe_deja = parent->getLocal()->existeDeja(nom_fichier);
        if(existe_deja && verifier_existe_deja)
        {
            widgetRemplacementFichier(parent->getLocal()->getRepCourant()+"/"+nom_fichier, icon);
        }
        if(!existe_deja || !verifier_existe_deja)
        {
            struct_put_get temp;
            temp.file = new QFile(parent->getLocal()->getRepCourant()+"/"+nom_fichier);
            temp.nom = nom;
            get_s->append(temp);

            parent->getMessages()->ajouterTelechargement(icon, parent->getLocal()->getRepCourant()+"/"+nom_fichier, false/*download*/);
        }
    }
    else
    {
        parent->getMessages()->ajouterMessage(QIcon(":/FTPImages/mauvais.gif"), tr("Vous n'tes connect   aucun serveur."), new QLabel(tr("Erreur")));
    }
}

void WidgetDistant::lancerGet(int serveur)
{
    file_dernier_upload = get_s->value(serveur).file;
    file_dernier_upload->open(QIODevice::WriteOnly);
    distant->getFtp()->get(get_s->value(serveur).nom, file_dernier_upload);
}

void WidgetDistant::closeDernierUpload()
{
    if(file_dernier_upload)
    {
        if(file_dernier_upload->isOpen())
        {
            file_dernier_upload->close();
        }
    }
}

void WidgetDistant::widgetRemplacementFichier(QString nom, QIcon icon)
{
    QWidget * msg = new QWidget(this, Qt::Dialog);
    msg->setWindowTitle(tr("Fichier existant !"));

    QHBoxLayout * layout = new QHBoxLayout(msg);

    QLabel * l = new QLabel(this);
    QPixmap p = QPixmap(icon.pixmap(QSize(50, 50)));
    QPixmap pixmap_bonne_taille = p.scaled(50, 50, Qt::IgnoreAspectRatio, Qt::SmoothTransformation);
    l->setPixmap(pixmap_bonne_taille);
    l->setMargin(30);
    layout->addWidget(l);

    QVBoxLayout * ss_layout = new QVBoxLayout();
    l = new QLabel(tr("Le fichier <b><font color=\"#FFF000000\">")+nom+tr("</font></b> existe dj  voulez-vous le remplacer ?"));
    ss_layout->addWidget(l, Qt::AlignCenter);
    ne_plus_demander_verification_fichier = new QCheckBox(tr("Toujours remplacer."), msg);
    ss_layout->addWidget(ne_plus_demander_verification_fichier, 500, Qt::AlignRight | Qt::AlignBottom);

    QHBoxLayout * ss_ss_layout = new QHBoxLayout();
    QPushButton * annuler = new QPushButton(QIcon(":/FTPImages/flag_red.gif"), tr("Annuler"));
    connect(annuler, SIGNAL(clicked()), msg, SLOT(close()));
    ss_ss_layout->addWidget(annuler);
    QPushButton * accepter = new QPushButton(QIcon(":/FTPImages/flag_green.gif"), tr("Accepter"));
    connect(accepter, SIGNAL(clicked()), msg, SLOT(hide()));
    connect(accepter, SIGNAL(clicked()), this, SLOT(widgetRemplacementFichierOk()));
    ss_ss_layout->addWidget(accepter);

    ss_layout->addLayout(ss_ss_layout);

    layout->addLayout(ss_layout);

    msg->setLayout(layout);

    msg->show();
}

void WidgetDistant::widgetRemplacementFichierOk()
{
    if(ne_plus_demander_verification_fichier->isChecked())
    {
        verifier_existe_deja = false;
        put(parent->getLocal()->getRepCourant()+"/"+parent->getLocal()->getLocal()->getDernierItem()->text(0),
            parent->getLocal()->getLocal()->getDernierItem()->icon(0));
    }
    else
    {
        verifier_existe_deja = false;
        if(parent->getLocal()->getLocal()->getDernierItem())
        {
            put(parent->getLocal()->getRepCourant()+"/"+parent->getLocal()->getLocal()->getDernierItem()->text(0),
                parent->getLocal()->getLocal()->getDernierItem()->icon(0));
        }
        verifier_existe_deja = true;
    }
}

DossiersDistants* WidgetDistant::getDistant()
{
    return distant;
}

void WidgetDistant::deconnection()
{
    distant->getFtp()->abort();
    parent->getMessages()->abort();
    distant->getFtp()->close();
}

